SUBROUTINE exchange (u, comm_cart, neigh_rank, num_neigh)
USE MPI
REAL u(0:101,0:101)
INTEGER comm_cart, num_neigh, neigh_rank(num_neigh)
INTEGER sndcounts(num_neigh), sndtypes(num_neigh)
INTEGER rcvcounts(num_neigh), rcvtypes(num_neigh)
INTEGER (KIND=MPI_ADDRESS_KIND) lb, sizeofreal, sdispls(num_neigh), &
rdispls(num_neigh)
INTEGER type_vec, i, ierr
! The following initialization need to be done only once
! before the first call of exchange.
CALL MPI_TYPE_GET_EXTENT(MPI_REAL, lb, sizeofreal, ierr)
CALL MPI_TYPE_VECTOR (100, 1, 102, MPI_REAL, type_vec, ierr)
CALL MPI_TYPE_COMMIT (type_vec, ierr)
sndtypes(1) = type_vec
sndtypes(2) = type_vec
sndtypes(3) = MPI_REAL
sndtypes(4) = MPI_REAL
DO i=1,num_neigh
sndcounts(i) = 100
rcvcounts(i) = 100
rcvtypes(i) = sndtypes(i)
END DO
sdispls(1) = ( 1 + 1*102) * sizeofreal ! first element of u( 1,1:100)
sdispls(2) = (100 + 1*102) * sizeofreal ! first element of u(100,1:100)
sdispls(3) = ( 1 + 1*102) * sizeofreal ! first element of u(1:100, 1)
sdispls(4) = ( 1 + 100*102) * sizeofreal ! first element of u(1:100,100)
rdispls(1) = ( 0 + 1*102) * sizeofreal ! first element of u( 0,1:100)
rdispls(2) = (101 + 1*102) * sizeofreal ! first element of u(101,1:100)
rdispls(3) = ( 1 + 0*102) * sizeofreal ! first element of u(1:100, 0)
rdispls(4) = ( 1 + 101*102) * sizeofreal ! first element of u(1:100,101)
! the following communication has to be done in each call of exchange
CALL MPI_NEIGHBOR_ALLTOALLW (u, sndcounts, sdispls, sndtypes, &
u, rcvcounts, rdispls, rcvtypes, comm_cart, ierr)
! The following finalizing need to be done only once
! after the last call of exchange.
CALL MPI_TYPE_FREE (type_vec, ierr)
END
